<?


define("CNFOLDER_FM_PROPS", 1);

class CNFolderObject extends CNInFolderObject {
 
 var $folder_id = 0;
 var $d_maps = NULL;
 var $d_updateRecursive;
 var $d_objectCounts;

 function CNFolderObject($folder_id=0) {
 parent::CNObject();
 $this->setID($folder_id);
 $this->d_updateRecursive = false;
 $this->setViewLinkParams("do=13020&FOLDER_ID=" . $this->getId());
 }

 function getTType() {
 global $T_FOLDER;
 return $T_FOLDER;
 }
 
 function _setID($id) {
 $this->folder_id = $id; 
 }

 function getID() {
 return $this->folder_id;
 }
 
 function getIcon() 
 {
 global $ICO_FOLDER;
 return $ICO_FOLDER;
 }

 


















 
 function getName() {
 return $this->getFieldValue("name");
 }
 
 function setName($name) {
 $this->setFieldValue("name", $name);
 }

 function setMotherId($mother_id) {
 $this->setFieldValue("mother", $mother_id);
 }
 
 function getMotherId() {
 return $this->getFieldValue("mother");
 }
 
 function setPubdir($pubdir) {
 $this->setFieldValue("pub_dir", $pubdir);
 }
 
 function getFolderId() {
 return $this->folder_id;
 }
 
 function getPropertyNames()
 {
 return array_merge( parent::getPropertyNames(),
 array("pub_dir"=>i18n("Folder"),
 "name"=>i18n("Name"),
 "description"=>i18n("Description"), 
 "mother"=>i18n("Mother"),
 "node"=>i18n("Node"),
 "maps"=>i18n("VMaps")
 ) );
 }

 function setUpdateRecursive($rec) {
 $this->d_updateRecursive = $rec;
 }

 function doUpdateRecursive() {
 return $this->d_updateRecursive;
 }

 function onInsertObject() {
 global $T_FOLDER, $W_CREATE;
 $folder_id = $this->getID();
 $mother_id = $this->getMotherId();
 $channel_id = $this->getFieldValue("channel_id");
 
 node_func("triggerEvent");
 node_func("logcmd");
 
 $sql = "SELECT node_id, type_id, channelset_id FROM folder WHERE id = ".sqlf_tl_num($mother_id);
 $rs = query($sql, true);
 $mother_type = $rs["arr"][0]["type_id"];

 if ($mother_type == T_DOMAIN && $channel_id > 0) {
 $mother_type = T_DOMAIN_CHANNEL;
 $sql = "SELECT id FROM folder WHERE channelset_id = ".sqlf_tl_num($rs["arr"][0]["channelset_id"])." AND channel_id = ".sqlf_tl_num($channel_id);
 $rs = query($sql);
 $perm_mother_id = $rs["arr"][0]["id"];
 } else {
 $perm_mother_id = $mother_id;
 }
 duplicate_perm($mother_type, $perm_mother_id, $T_FOLDER, $folder_id);

 duplicate_tplfolder($mother_id,$folder_id);

 duplicate_foldertags($mother_id,$folder_id);

 
 logcmd($W_CREATE, $this->getFieldValue("type_id"), $folder_id , $this->getFieldValue("node_id"), "CNFolderObject::onInsertObject");
 triggerEvent( $T_FOLDER, $folder_id, EVENT_CREATE, new EventObject() );
 triggerEvent( $T_FOLDER, $mother_id, EVENT_UPDATE | EVENT_CHILD, new EventChildObject(T_FOLDER, $folder_id) );
 
 trigger_event( "onfoldercreate", array("folder_id"=>$mother_id, "new_folder_id"=>$folder_id)); 
 
 }

 function onUpdateObject() {
 global $FEATURE, $T_FOLDER, $W_EDIT;
 
 


 if ($this->d_objectFieldValues == $this->d_objectLoadedFieldValues) {
 return;
 }
 
 node_func( "triggerEvent" );
 node_func( "logcmd" );
 node_include("dirt");
 
 
 logcmd($W_EDIT, $T_FOLDER, $this->getID() , 0, "CNFolderObject::onUpdateObject");
 if ($this->d_updateRecursive) folder_rec_update($this->getID(),$this->getFieldValue("pub_dir"));

 
 $modified = array();
 if ( $this->d_objectFieldValues["name"] != $this->d_objectLoadedFieldValues["name"] ) {
 $modified[] = "name";
 }
 if ( $this->d_objectFieldValues["pub_dir"] != $this->d_objectLoadedFieldValues["pub_dir"] ) {
 $modified[] = "pub_dir";
 }
 if ( $this->d_objectFieldValues["description"] != $this->d_objectLoadedFieldValues["description"] ) {
 $modified[] = "description";
 }
 triggerEvent( $T_FOLDER, $this->getID(), EVENT_UPDATE, new EventObject(null, $modified) );
 }

 function onBeforeDeleteObject() {

 }

 function canInsert() {
 global $USER_ID, $T_FOLDER, $DIC;
 $type = $this->getFieldValue("type_id")?$this->getFieldValue("type_id"):$T_FOLDER;
 node_include("perm");
 if (!perm($USER_ID, $type, $this->getFieldValue("mother"), 8)) {
 $this->_setError(new NodeException(i18n('no_permission_to_create_a')), "mother");
 return false;
 }
 return true;
 }

 function canUpdate() {
 global $USER_ID, $T_FOLDER, $DIC;
 $type = $this->getFieldValue("type_id")?$this->getFieldValue("type_id"):$T_FOLDER;
 node_include("perm");
 if (!perm($USER_ID, $T_FOLDER, $this->getFieldValue("mother"), 9)) {
 $this->_setError(new NodeException(i18n('827.you_have_no_permission_to')), "mother");
 return false;
 }
 return true;
 }

 function canDelete() {
 $this->_setError(new NodeException(i18n("delete not implemented for CNFolder.")));
 return false;
 }
 
 function delete() {
 return cmd_folder_del($this->getID());
 }
 
 function &getProperty($key) {
 switch (strtolower($key)) {
 case "id": 
 $class = new StringObject($this->getID());
 break;
 case "name":
 $class = new StringObject($this->getFieldValue("name"));
 break;
 case "node":
 $class = new CNNodeObject($this->getFieldValue("node_id"));
 break;
 case "pub_dir":
 $class = new StringObject($this->getFieldValue("pub_dir"));
 break;
 case "description":
 $class = new StringObject($this->getFieldValue("description"));
 break;
 case "mother":
 if ($this->getFieldValue("mother") > 0) {
 $class = new CNFolderObject($this->getFieldValue("mother"));
 } else {
 $class = new CNNodeObject($this->getFieldValue("node_id"));
 }
 break;
 case "folder":
 $class = new CNFolderObject($this->folder_id);
 break;
 




 default: 
 $class =& parent::getProperty($key);
 }
 return $class;
 }
 
 function checkErrors() {
 global $T_FOLDER, $DIC, $FOLDER_REGEX_ALLOWED_CHARACTERS;
 if (!$this->getFieldValue("type_id")) $this->setFieldValue("type_id", $T_FOLDER);
 if (!$this->getFieldValue("startpage_id")) $this->setFieldValue("startpage_id", 0);
 $ret = true;
 
 $mother_id = $this->getFieldValue("mother");
 if ($mother_id === NULL || $mother_id === "") {
 $this->_setError(new NodeException(i18n("Mother Id not set for new folder.")), "mother");
 $ret = false;
 }
 
 
 $sql = "SELECT node_id, type_id FROM folder WHERE id = ".sqlf_tl_num($mother_id);
 $rs = query($sql, true);
 $mother_type = $rs["arr"][0]["type_id"];
 $this->setFieldValue("node_id", $rs["arr"][0]["node_id"]);

 node_func("folder_exists");
 if (folder_exists($this->getName(), $mother_id, $this->getID())) {
 $this->_setError(new NodeException(i18n('a_folder_with_this_name')), "name");
 $ret = false;
 }

 if ( strlen($this->getName()) < 1 ) {
 $this->_setError(new NodeException(i18n("Invalid folder name")), "name");
 $ret = false;
 }

 node_include("validation");

 $requ = new NodeInputValidationRequest();
 $resp = validate_input("folderName", $this->getName(), $requ);
 $this->setName($resp->getCleanMarkup());
 if ($resp->isError()) {
 $this->_setError(new NodeException(i18n("validation.invalid.foldername")), "name");
 $ret = false;
 }

 $validate = $this->getFieldValue("description");
 $requ = new NodeInputValidationRequest();
 $resp = validate_input("folderDescription", $validate, $requ);
 $this->setFieldValue("description", $resp->getCleanMarkup());
 if ($resp->isError()) {
 $this->_setError(new NodeException(i18n("validation.invalid.folderdescription")), "description");
 $ret = false;
 }

 $pub_dir = $this->getFieldValue("pub_dir");

 
 if (!preg_match("/^[$FOLDER_REGEX_ALLOWED_CHARACTERS]+$/", $pub_dir)) {
 $this->_setError(new NodeException(i18n("pub_dir_regexp_error")), "pub_dir");
 $ret = false;
 }
 
 if (strstr($pub_dir, "//")) {
 $this->_setError(new NodeException(i18n("pub_dir_doubleslash")), "pub_dir");
 $ret = false;
 }
 
 if (!$pub_dir) $pub_dir = "/";
 else {
 if ($pub_dir[0] != "/") $pub_dir = "/".$pub_dir;
 if ($pub_dir[strlen($pub_dir)-1] != "/") $pub_dir .= "/";
 }
 $this->setFieldValue("pub_dir", $pub_dir);

 if (!$this->isNew()) {
 if (folder_pagecheck($this->getID(),$pub_dir, 'page', $this->d_updateRecursive) || folder_pagecheck($this->getID(),$pub_dir,"contentfile",$this->d_updateRecursive)) {
 $this->_setError(new NodeException(i18n('the_publishing_directory')), "pub_dir");
 $ret = false;
 }
 }

 return $ret;
 }

 function getValueFields() {
 return array("name"=>"text", "node_id"=>false, "pub_dir"=>"text", "startpage_id"=>false, "description"=>"textarea", "mother"=>false,
 "type_id"=>false, "channelset_id" => false, "channel_id" => false, "is_master" => false);
 }

 function &getFormObject() { return new CNFolderFormObject($this); }

 function _getNodeTable() { return "folder"; }

 function _getFolderColumn() {
 return "mother";
 }

 function _storeUserInfo() { return true; }

 function _checkPermission($parentObjectType, $parentObjectId) {
 global $USER_ID;
 return perm($USER_ID, $this->getTType(), $this->getID(), 0);
 }

 



 function getObjectCount($objecttype) {
 global $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $SESSION_TOKEN, $NODE_ID, $CONTENTGROUP_ID, $CONTENTGROUPS;
 if (!$this->d_objectCounts) {
 $fc = new fetchCurl();

 load_contentgroups();
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/folder/count/".$this->getID()."?sid=$SESSION_TOKEN&nodeId=$NODE_ID&language=".$CONTENTGROUPS[$CONTENTGROUP_ID]["code"];

 $fc->setUrl($url);
 $json = $fc->doRequest();

 
 if ($fc->getReturnCode() == '') {
 halt(7,'Unable to connect to CNPortletapp.');
 } else if ($fc->getReturnCode() >= 400) {
 halt(120, 'Accessing CNPortletapp returned error '.$fc->getReturnCode());
 }

 $counts = json_decode($json,true);
 $this->d_objectCounts = array(
 T_FOLDER => $counts["folders"],
 T_TEMPLATE => $counts["templates"],
 T_PAGE => $counts["pages"],
 T_IMAGE => $counts["images"],
 CT_FILE => $counts["files"]
 );
 }
 return is_numeric($this->d_objectCounts[$objecttype]) ? $this->d_objectCounts[$objecttype] : false;
 }

 




 function getChannelsetId($create = false) {
 global $FEATURE, $T_FOLDER;

 $channelset_id = $this->getFieldValue("channelset_id");
 if (!$channelset_id && $create) {
 $sql = "INSERT INTO channelset (id) VALUES (NULL)";
 $rs = query($sql);
 $channelset_id = $rs["iid"];

 $sql = "UPDATE folder SET channelset_id = ".sqlf_tl_num($channelset_id)." WHERE id = ".sqlf_tl_num($this->getID());
 query($sql);

 $this->setFieldValue("channelset_id", $channelset_id);

 
 if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_FOLDER, $this->getID());
 }
 }
 return $channelset_id;
 }
}

class CNInheritedFolderObject extends CNFolderObject {
 function CNInheritedFolderObject($folder_id=0) {
 parent::CNFolderObject($folder_id);
 }

 function getTType() {
 global $T_FOLDER_CHANNEL;
 return $T_FOLDER_CHANNEL;
 }
}

class CNNodeObject extends CNFolderObject {

 var $node_id;
 var $m_mapsInitialized = false;
 var $m_maps = NULL;
 var $m_self = NULL;

 function CNNodeObject($id = 0) {
 parent::CNFolderObject(0);
 $this->setID($id);
 }

 function getTType() {
 global $T_NODE;
 return $T_NODE;
 }
 
 function getIcon() {
 global $ICO_DOMAIN;
 return $ICO_DOMAIN;
 }
 
 function getPropertyNames()
 {
 return array_merge( parent::getPropertyNames(),
 array("hostr"=>i18n("Host"),
 "map"=>i18n("Map"),
 "folder" => i18n("Folder"),
 ) );
 }
 
 function _setID($id) {
 
 if ($id) {
 $sql = "SELECT folder_id FROM node WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql, true);
 $folder_id = $rs["arr"][0]["folder_id"];
 } else {
 $node_id = 0;
 $folder_id = 0;
 }
 
 parent::_setID($folder_id);
 $this->node_id = (int) $id;
 }

 function getID() {
 return (int) $this->node_id;
 }

 function _getNodeIdFromFolderID($folder_id) {
 if ($folder_id) {
 $sql = "SELECT node_id FROM folder WHERE id = ".sqlf_tl_num($folder_id);
 $rs = query($sql, true);
 $node_id = $rs["arr"][0]["node_id"];
 } else {
 $node_id = 0;
 $folder_id = 0;
 }
 return (int)$node_id;
 }
 
 function initFromFolderID($folder_id) {
 $this->setID( $this->_getNodeIdFromFolderID($folder_id) );
 }
 
 function _setIDFromFolderID($folder_id) {
 $this->node_id = $this->_getNodeIdFromFolderID($folder_id);
 parent::_setID($folder_id);
 }

 function _initMaps()
 {
 global $T_MAP;
 if ( $this->m_mapsInitialized ) return;
 $sql = "SELECT * FROM cn_map WHERE node_id=".sqlf_tl_num($this->node_id)." AND mother_id=0";
 $rs = query( $sql );
 $coll = new NodeObjectCollection( $T_MAP );
 foreach ( $rs["arr"] as $row )
 {
 unset( $map );
 $map = new CNMapObject( );
 $map->initFromResultset( $row );
 $coll->add( $map ); 
 }
 $this->m_maps =& $coll;
 $this->m_mapsInitialized = TRUE;
 }
 
 function& getProperty($key) {
 if (!$this->node_id) return new StringObject("");
 if ( $this->m_self === NULL )
 {
 $sql = "SELECT host, pub_dir FROM node WHERE id = ".sqlf_tl_num($this->node_id);
 $rs = query($sql, true);
 $r = $rs["arr"][0];
 $this->m_self = $r;
 }
 else
 $r = $this->m_self;
 switch ($key) {
 case "id":
 $class = new StringObject($this->getID());
 break;
 case "host":
 $class = new StringObject($r["host"]);
 break;
 case "pub_dir":
 $class = new StringObject($r["pub_dir"]);
 break;
 case "maps":
 $this->_initMaps();
 $class =& $this->m_maps; 
 break;
 default:
 $folder =& new CNFolderObject($this->getFolderId());
 $class =& $folder->getProperty($key);
 }
 return $class;
 }

 function getParentTType() {
 return array(T_CONTENT);
 }

 function searchInObject($objecttype, $objectid, $searchterm=null, $recursive=false, $fulltext=false, $ignoreorder=false) {
 return SearchableObject::searchInObject($objecttype, $objectid, $searchterm, $recursive, $fulltext, $ignoreorder);
 }

 function _getBaseFilter() {
 return "type_id = 10001";
 }

 function _checkSearchTerm($searchterm) {
 if (! $searchterm) {
 return true;
 }
 $name = $this->getFieldValue("name");
 if (strpos(strtolower($name), strtolower($searchterm)) !== FALSE) {
 return true;
 }
 return false;
 }

 function delete() {
 return cmd_node_del($this->getID());
 }
}

class CNChannelObject extends CNNodeObject {
 function CNChannelObject($id = 0) {
 parent::CNNodeObject($id);
 }

 function getTType() {
 global $T_DOMAIN_CHANNEL;
 return $T_DOMAIN_CHANNEL;
 }
}





class CNFolderNodeObject extends CNNodeObject {

 var $node_folderid;

 function CNFolderNodeObject($id = 0) {
 parent::CNNodeObject();
 $this->node_folderid = $id;
 $this->initFromFolderID($id);
 }

 function _setID($id) {
 $this->_setIDFromFolderID($id);
 $this->node_folderid = $id;
 }
 
 function getID() 
 {
 return $this->node_folderid;
 }
}

class CNFolderFormObject extends NodeFormObject {

 var $mode;
 
 function CNFolderFormObject(&$folderObject, $mode = CNFOLDER_FM_PROPS) {
 parent::NodeFormObject($folderObject);
 $this->mode = $mode;
 }

 function getSerializeKey() {
 return array("parent"=>parent::getSerializeKey(), "mode"=>$this->mode);
 }

 function initFromSerializeKey($key) {
 parent::initFromSerializeKey($key["parent"]);
 $this->mode = $key["mode"];
 }

 function setMode($mode = CNFOLDER_FM_PROPS) {
 $this->mode = $mode;
 }

 function getValueFields() {
 global $FEATURE;
 $rs = array();
 $obj =& $this->getEditObject();
 if ($this->mode & CNFOLDER_FM_PROPS) {
 $rs += array("name"=>"text", "pub_dir"=>"text", "description"=>"textarea");
 if (!$obj->isNew()) $rs += array("rec"=>false);
 }
 return $rs;
 }

 function getFieldLabels() {
 global $DIC;
 return array("name"=>i18n("Name"), "pub_dir"=>i18n('directory'), "rec"=>i18n('include_subfolders'), "description"=>i18n("Description"), "startpage_id"=>i18n("Startpage"));
 }

 function getFieldDescriptions() {
 return array("rec"=>i18n('das_verzeichnis_auch_fr'));
 }

 function isEditableField($field) {
 return true;
 }

 function isOptionalField($field) {
 if ($field == "description") return true;
 return false;
 }

 function &getFormComponent($field) {
 global $FEATURE, $DIC;
 $obj =& $this->getEditObject();
 switch ($field) {
 case "startpage_id":
 if (!$FEATURE["realeditor"]) break;
 node_class("pageselector");
 node_class("minibrowserhiselector");
 $comp = new MinibrowserHiSelector(new PageSelector(0,0,$this->getFieldValue("startpage_id")), 
 i18n("Startpage"), true);
 break;
 case "rec":
 node_class("checkboxcomponent");
 $comp = new CheckboxComponent(i18n('include_subfolders'));
 break;
 default:
 $comp = false;
 }
 return $comp;
 }

 function storeFormComponent($field, &$component) {
 $obj =& $this->getEditObject();
 switch ($field) {
 case "startpage_id":
 $obj->setFieldValue("startpage_id", (int) $component->getResult());
 break;
 case "rec":
 $obj->setUpdateRecursive($component->isChecked());
 break;
 }
 }
 
}

?>
