<?

class CNTagMapEntryObject extends SearchableObject {

 var $id = 0;
 
 function CNTagMapObject($id=0) {
 parent::CNObject();
 $this->setID($id);
 }

 function getTType() {
 return T_TAGMAP_ENTRY;
 }

 function getParentTType() {
 return array(T_TAGMAP_EDITOR);
 }

 function _setID($id) {
 $this->id = $id; 
 }

 function getID() {
 return $this->id;
 }
 
 function getIcon() {
 global $ICO_CONTENTMAP;
 return $ICO_CONTENTMAP;
 }

 function _getNodeTable() {
 return "tagmap";
 }
 
 function getValueFields() {
 return array('tagname'=>'text', 'mapname'=>'text', 'object'=>'int');
 }

 function getDisplayName() {
 global $T_TYPE;
 return $this->getFieldValue("mapname") . " (" . $this->getFieldValue("tagname") . ") [" 
 . $T_TYPE[$this->getFieldValue("object")]["name"] . "]";
 }

 function getCategoryName() {
 global $T_TYPE;
 return $T_TYPE[$this->getFieldValue("object")]["name"];
 }

 function& getProperty( $key ) {
 switch ( $key ) {
 case "id":
 return new IntObject($this->getID());
 case "name":
 return new StringObject($this->getFieldValue("name"));
 default:
 return parent::getProperty($key);
 } 
 }

 function _checkPermission($parentObjectType, $parentObjectId) {
 global $USER_ID;
 return perm($USER_ID, $parentObjectType, $parentObjectId, 0);
 }

 function _checkSearchTerm($searchTerm) {
 if (! $searchTerm) {
 return true;
 }
 $tagname = $this->getFieldValue("tagname");
 $mapname = $this->getFieldValue("mapname");
 if (strpos(strtolower($tagname), strtolower($searchTerm)) !== FALSE) {
 return true;
 }
 if (strpos(strtolower($mapname), strtolower($searchTerm)) !== FALSE) {
 return true;
 }
 return false;
 }

 function _getSearchFilter($searchTerm) {
 return null;
 }
}

?>
