<?

class TemplateDatasource extends ItemListActionDatasource {

 var $m_folder;
 var $m_rec;
 var $m_islink;

 function TemplateDatasource( $folder_id, $recursive = false ) {
 $this->m_folder = $folder_id;
 $this->m_rec = $recursive;
 $this->m_islink = false;
 }

 function getSerializeKey() {
 $rs["parent"] = parent::getSerializeKey();
 $rs["folder"] = $this->m_folder;
 $rs["rec"] = $this->m_rec;
 return $rs;
 }

 function initFromSerializeKey( $key ) {
 parent::initFromSerializeKey( $key["parent"] );
 $this->m_folder = $key["folder"];
 $this->m_rec = $key["rec"];
 }
 
 function setItemLink( $js ) {
 $this->makeJsLink( "lname", "name", $js, "", "id" );
 $this->m_islink = true;
 }
 
 function getPlainResultSet( $fromIdx, $toIdx, &$count, $search = "" ) {
 if ($this->m_rec) {
 $folders = $this->m_folder;
 } else {
 $folders = $this->m_folder;
 }
 
 $sql = "SELECT id, name FROM template, template_folder WHERE template.id = template_folder.template_id AND template_folder.folder_id IN (".sqlf_value_list($folders).") GROUP BY template.id ORDER BY template.name";
 
 $rs = query($sql);
 
 $count = $rs["num"];
 
 return $rs["arr"];
 }

 function hasColumnHeaders() {
 return true;
 }

 function getColumns() {
 return array( $this->m_islink?"lname":"name" );
 }

 function getColumnHeader( $header ) {
 node_include("i18n");
 switch ($header) {
 case "lname": 
 case "name": return i18n("Template");
 case "name": return i18n("Template");
 }
 }

}

?>
