<?
GUIFactory::setMainGUI( "main" );

$o_type_list[0] = i18n('415.all');
while (list($k, $v) = each($T_TYPE)) {
 
 if ($v["object"]) {
 $name = ($v["name"])?$v["name"]:$k;
 $o_type_list[$k] = "$name [$k]";
 }
}

$o_type_list[10113] = i18n("Objectproperty")." [10113]";
asort($o_type_list);

$f = $HI["sel"];
$f["label"] = i18n('399.object');
$f["var"] = "qry_o_type";
$f["list"] = $o_type_list;
$f["help"] = i18n('an_action_has_e.g._the');
$f["force"] = false;
$hi[] = $f;

$cmd_desc_list[0] = i18n('415.all');
reset($CMD_DESC);
$cmd_desc_sqllist = Array();
while (list($k, $v) = each($CMD_DESC)) {
 $cmd_desc_list[$k] = "$v [$k]";
 $cmd_desc_sqllist[] = $k;
}
asort($cmd_desc_list);

$f = $HI["sel"];
$f["label"] = i18n('389.action');
$f["var"] = "qry_cmd_desc_id";
$f["list"] = $cmd_desc_list;
$f["help"] = i18n('an_action_has_e.g._the');
$f["force"] = false;
$hi[] = $f;

$f = $HI["text"];
$f["label"] = i18n('user');
$f["var"] = "qryname";
$f["regid"] = 9;
$f["help"] = i18n('the_term_entered_will_be');
$hi[] = $f;

$f = $HI["int"];
$f["label"] = i18n( "ID" );
$f["optional"] = true;
$f["var"] = "qryid";
$hi[] = $f;

$f = $HI["int"];
$f["label"] = i18n( "Info" );
$f["optional"] = true;
$f["var"] = "qryid2";
$hi[] = $f;

if (!$qrytimeto || !$qrytimefrom) {
$qrytimeto = date("Y-m-d H:i:s", ($_POST["f_qrytimeto"]) ? $_POST["f_qrytimeto"] : mktime());
$qrytimefrom = date("Y-m-d H:i:s", ($_POST["f_qrytimefrom"]) ? $_POST["f_qrytimefrom"] : mktime() - 3600);
}

$f = $HI["text"];
$f["label"] = i18n("sn_starttime");
$f["var"] = "qrytimefrom";
$f["regid"] = 43;
$hi[] = $f;

$f = $HI["text"];
$f["label"] = i18n("sn_endtime");
$f["regid"] = 43;
$f["var"] = "qrytimeto";
$hi[] = $f;


$f = $HI["ok"];
$f["label"] = i18n("search");
$hi[] = $f;

$lst = new item_list;
$lst->enablePaging = true;



$f = new htmlform($hi);
if ($f->issubmit) {
 $qry_o_type = $f_qry_o_type;
 $qry_cmd_desc_id = $f_qry_cmd_desc_id;
}

if ($qryname || $qry_o_type || $qry_cmd_desc_id || $hours || $timestamp || $qrytimefrom || $qrytimeto) {
 $search = "";
 if ($qryname && !$timestamp) {
 $a_qryname = sqlslashes($qryname);
 $search = " AND (LOWER(systemuser.login) LIKE '%".sqlf_escaped(strtolower($a_qryname))."%' OR LOWER(systemuser.firstname) LIKE '%".sqlf_escaped(strtolower($a_qryname))."%' OR LOWER(systemuser.lastname) LIKE '%".sqlf_escaped(strtolower($a_qryname))."%') ";
 }
 if ($qry_cmd_desc_id && !$timestamp)
 $search .= " AND (logcmd.cmd_desc_id = " . sqlf_tl_num((int)$qry_cmd_desc_id) . ")";
 if ($qry_o_type && !$timestamp)
 $search .= " AND (logcmd.o_type = " . sqlf_tl_num((int)$qry_o_type) . ")";
 if ( $qryid && !$timestamp)
 $search .= " AND (logcmd.o_id = " . sqlf_tl_num((int)$qryid) . ")";
 if ( $qryid2 && !$timestamp )
 $search .= " AND (logcmd.o_id2 = " . sqlf_tl_num((int)$qryid2) . ")";
 if (($qrytimefrom && $qrytimeto) && !$timestamp) 
 $search .= " AND (logcmd.timestamp >= unix_timestamp('" . sqlslashes($qrytimefrom) . "'))"
 . "AND (logcmd.timestamp <= unix_timestamp('" . sqlslashes($qrytimeto) . "'))";
 if ($timestamp) 
 $search .= " AND (logcmd.timestamp = " . sqlf_tl_num((int)$timestamp) . ")";
 
 $ires = item_order("timestamp","DESC");

 $sql_sysuser = "";
 if ($USER_ID != 1) {
 
 $sql_sysuser = " AND logcmd.user_id != 1 ";
 }
 
 node_include("folder_tree"); 
 $sql = "SELECT logcmd.id, logcmd.cmd_desc_id, logcmd.o_type, logcmd.o_id, logcmd.o_id2, logcmd.timestamp, logcmd.info, logcmd.user_id, systemuser.firstname, systemuser.lastname, lastname AS name ".$ires["select"]." 
FROM logcmd LEFT JOIN systemuser
ON systemuser.id = logcmd.user_id WHERE logcmd.cmd_desc_id != 350 $sql_sysuser AND 1=1 $search ORDER BY timestamp DESC";
 $rs = query($sql);
 if ($rs["arr"]) {
 while (list($key,$val) = each($rs["arr"])) {
 
 if ($val["o_type"] == $T_OBJPROPELEMENT) {
 $o_namers = query("SELECT name FROM objtag where id = " . sqlf_tl_num($val["o_id"]));
 $val["info"] = linkOpropEntry($val["o_id"], $val["info"], $val["o_id2"]);
 $val["o_id2"] = $o_namers["arr"][0]["name"];
 
 }

 $val["icon"] = img($T_TYPE[$val["o_type"]]["folderopen"]);
 $val["o_type"] = $T_TYPE[$val["o_type"]]["name"];
 $val["timestampunformatted"] = $val["timestamp"];
 $val["timestamp"] = db2date($val["timestamp"], "d.m.Y H:i:s");
 if ($USER_ID == 1 || $val["user_id"] > 1) {
 $val["name"] = htmlentities($val["lastname"] ." ".$val["firstname"], ENT_COMPAT, 'UTF-8');
 } else {
 $val["name"] = "[internal]";
 }
 $version_cmd = ($val["cmd_desc_id"] == W_VERSION || $val["cmd_desc_id"] == W_MAJORVERSION || $val["cmd_desc_id"] == W_RESTORE);
 $val["cmd_desc_id"] = $CMD_DESC[$val["cmd_desc_id"]];
 if ($version_cmd) {
 $val["cmd_desc_id"] .= " (".$val["info"].")";
 }
 if ($qry_o_type == T_PAGE) {
 $val["folder_id"] = $val["o_id2"];
 $val["o_id2"] = $val["o_id2"] = get_folder_path( get_folder_tree($val["o_id2"]), 0 );
 }
 
 $o_logcmd[$key] = $val;
 }
 }
}

function linkOpropEntry($opropid, $oid,$ttype) {
 global $T_TYPE;
 $table = "";
 switch ($ttype) {
 case 10002:
 $table = "folder";
 break;
 case 10006:
 $table = "template";
 break;
 case 10007:
 $table = "page";
 break;
 case 10008:
 $table = "contentfile";
 break;
 case 10011:
 $table = "contentfile";
 break;
 default:
 return;
 break;
 }
 
 $rs = query("SELECT name FROM ".sqlf_table($table)." WHERE id = ".sqlf_tl_num($oid));
 return "<img src='" . $T_TYPE[$ttype]["folderopen"] . "'> " .$rs["arr"][0]["name"] . " ($oid)"; 
}


load_menu(301,$T_LOGACTION,$t);

?>
