<?




define("SCHEDULER_STATUS_SUSPENDED", 0);
define("SCHEDULER_STATUS_RUNNING", 1);
define("SCHEDULER_STATUS_SUSPENDING", 2);

define("SCHEDULER_SUSPEND_FILE_NAME", "/../tmp/scheduler.suspend");




class Scheduler {
 




 function suspend($ignoreJobIds=-1) {
 global $USER_ID, $FILEPATH;
 $fp = fopen($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME, "w+");
 fputs($fp, $ignoreJobIds);
 fclose($fp);
 }
 
 



 function getStatus() {
 global $FILEPATH;
 if (file_exists($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)) {
 if (Scheduler::isAnyJobRunning()) {
 return SCHEDULER_STATUS_SUSPENDING;
 } else { 
 return SCHEDULER_STATUS_SUSPENDED;
 }
 } else {
 return SCHEDULER_STATUS_RUNNING;
 }
 }
 
 


 function resume() {
 global $FILEPATH;
 if (file_exists($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)) {
 unlink($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME);
 }
 }
 
 





 function isAnyJobRunning() {
 global $FILEPATH;

 
 if (file_exists($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)) {
 $jobIds = trim(file_get_contents($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)); 
 if (strlen($jobIds) > 0 && $jobIds !== 'undefined') {
 $sqlpart = "AND job_id NOT IN (".sqlf_tl_num_list($jobIds).")";
 }
 }
 $res = query("SELECT * FROM jobrun WHERE starttime > 0 AND endtime = 0 AND valid = 1 $sqlpart");
 if ($res["num"] == 0) {
 return false;
 } else {
 return true;
 }
 }
 
 






 function allowRun($jobId) {
 global $FILEPATH;
 if (file_exists($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)) {
 $jobIds = trim(file_get_contents($FILEPATH . SCHEDULER_SUSPEND_FILE_NAME)); 
 if (strlen($jobIds) > 0) {
 if (in_array($jobId, explode(",", $jobIds))) {
 return true;
 }
 }
 return false;
 } 
 return true;
 }
}
?>