<?
/**
 * This file is not really dynamic, since it will be cached by Browsers
 * (doesn't have a timestamp in the request URL).
 * Don't do anything here that may change between requests.
 * Since a session ID is included in the request URL, this file will be
 * cached until the next session.
 * Using $STAG is OK, if it is for files that have a similar lifetime.
 */
global $STAG, $MENU_WIDTH;
?>
var nodesubmenu1_clicked = false;
var menu_frame = (top.main)?(top.main.list):null;
var menu_layer = 'nodesubmenu1';
var over_menu = -1;
var last_name = '';
var last_index = -1;
var time_hide = 150; 
var scrollbar_width = 3;
var scrollposx = -1;
var scrollposy = -1;
var scrolltimeout = 350;
var scrollTimer;
var node_menu_width = <?= $MENU_WIDTH ?>;
var root_posx = 0;
var activeMenuIndex = -1;
var activeMenuElement = null;
var doubleClass = RegExp('(\\s|^)double(\\s|$)');

if (top.tree != null){
	if (top.tree.keepMenuThere) {
		top.tree.keepMenuThere();
	}
}

function click_menu(name, index, element) {
	this.className += " menu_active";
	if (nodesubmenu1_clicked) {
		nodesubmenu1_clicked = false;
		hide_menu();
	} else {
		nodesubmenu1_clicked = true;
		show_menu(name, index, element);
	}
	return true;
}

function set_menuclicked(value) {
	nodesubmenu1_clicked = value;
}

function hide_menu() {
	if (over_menu > -1 && nodesubmenu1_clicked) return;
	var l = get_layer(menu_layer, menu_frame);
	hide_layer(l);

	if (activeMenuElement != null) {
		activeMenuIndex = -1;
		activeMenuElement.className = '';
		activeMenuElement = null;
	}
}

function gen_menu_entry (el, name, index) {
	var entry = '';
	if (el['name']) {
		entry = '<a class=\"submenuLink\" href=\"' + el['link'] + '\" ';
		entry += ' target="' + el['target'] + '"';
		entry += ' onmouseover=\"this.className = \'submenuLinkSel\'; subON(\'' + name + '\', \'' + index + '\',\'' + el['index'] + '\', \'' + el['name_on'] + '\');\"';
		entry += ' onmouseout=\"this.className = \'submenuLink\'; subFF(\'' + name + '\', \'' + index + '\',\'' + el['index'] + '\', \'' + el['name_ff'] + '\');\"';
		entry += ' onclick=\"hide_layer(get_layer(\'' + menu_layer + '\'));return true\"';
		entry += '>';
		if (el['icon']){
			entry += '<img src=\"' + el['icon'] + '\" width=\"18\" height=\"18\" border=0 alt=\"\">';
		}else {
			entry += '<div class=\"imgPlaceholder\">&nbsp;</div>';
		}
		entry += '<span>' + el['name'] + '</span>';
		entry += '</a>';
	}
	return entry;
}

function show_menu(name, index, element) {

	if (activeMenuElement != null) {
		// clear old first
		activeMenuElement.className = '';
	}

	activeMenuIndex = index;
	activeMenuElement = element;
	element.className = 'menu_active';

	if (nodesubmenu1_clicked) {
		var value = '';
		value = '<link rel="stylesheet" href="<?=$STAG?>&do=20&url=lib/css/gui.css" type="text/css">\n';

		for(sub in menus[name]) {
			if (menus[name][sub]['name']) {
				value += gen_menu_entry(menus[name][sub], name, index);
			}
		}

		var i=0;
		var l = get_layer(menu_layer, menu_frame);

		if (element != null) {
			i = element.offsetLeft;

			if (top.logo && top.tree && top.main.ass) {
				var relativeOffset = top.tree.getWindowWidth(top.logo) - top.tree.getWindowWidth(top.tree) - top.tree.getWindowWidth(top.main.ass);

				if (relativeOffset > 0) {
					i += relativeOffset;
				}
			}

			i -= 2;
		}
		else {
			i = menus[name]['layer_pos'];
			if (menus[name]['align'] == 'r') {
				if (document.all) {
					var j = menu_frame.document.body.offsetWidth;
				} else {
					var j = menu_frame.innerWidth;
				}
				i = (j - layer_right) + i;
			}
		}

		move_layer(l, i);
		write_layer(l, value);
		show_layer(l);
		clearTimeout(scrollTimer);
		scrollposx = -1;
		scrollposy = -1;
		root_posx = 0;
		scroll_menu_do(i);

		var subMenuElement = menu_frame.document.getElementById("nodesubmenu1");
		var height = 0;

		// if an Aloha-IFrame is used to display the data, use its height instead of the list-frame's
		if (menu_frame.document.getElementById("gcn-aloha-iframe") !== null ) {
			height = menu_frame.document.getElementById("gcn-aloha-iframe").clientHeight;
		}
		else {
			height = menu_frame.document.documentElement.clientHeight;
		}

		// increases width of submenu if content would not fit inside the frame
		if (!subMenuElement.className.match(doubleClass) && height > 0 && subMenuElement.clientHeight > height) {
			subMenuElement.className += " double";
		}

		// resets width to single column if content fits
		if (subMenuElement.className.match(doubleClass) && height > 0 && (subMenuElement.clientHeight * 2) < height) {
			subMenuElement.className = subMenuElement.className.replace(doubleClass, ' ');
		}
	}
}

function set_mymenu(name, title) {
	var val = '';
	val = top.main.ass.gen_info_linklist(menus[name]);
	var actions = new Array();
	actions[0] = new Array();
	actions[0]['icon'] = '<?=$STAG_PREFIX?>?do=11&module=system&img=close_small.png';
	actions[0]['link'] = 'javascript:unset_infobox(\'mymenu\');';
	top.main.ass.set_infobox('mymenu',title,val,actions);
}

function menuON(name, index, element) {
	activeMenuIndex = index;
	over_menu = index;
	last_name = name;
	last_index = index;
	imgFFall();
	imgON(index);
	show_menu(name, index, element);
}

function menuFF(name, index) {
	over_menu = -1;
	if (!nodesubmenu1_clicked) setTimeout('imgFF('+index+')',time_hide);
}

function imgON(index) {
	var imgName = 'img' + index;
	var l = get_layer('menu');
	if (l.document && l.document.images[imgName]) {
		l.document.images[imgName].src = eval(imgName +'on.src');
	} else if (document.images[imgName]) {
		document.images[imgName].src = eval(imgName +'on.src');
	}
}

function imgFF(index) {
	if (over_menu == index) return;
	var imgName = 'img' + index;
	var l = get_layer('menu');
	if (l.document && l.document.images[imgName]) {
		l.document.images[imgName].src = eval(imgName +'ff.src');
	} else if (document.images[imgName]) {
		document.images[imgName].src = eval(imgName +'ff.src');
	}
}

function imgFFall() {
	if ( !imgs ) return;
	for (img in imgs) {
		imgFF(img);
	}
}

function move_menu () {
	try {
		// Get width of ass
		if (top.main) if (top.main.ass) {
			var f = top.main.ass;
			var t = top.main.document.getElementById("fsContent");
			if (t.rows) {
				var wa = 0;
			} else {
				if (f.innerWidth) {
					var wa = f.innerWidth;
				} else if (f.document.documentElement && f.document.documentElement.clientWidth) {
					var wa = f.document.documentElement.clientWidth;
				} else if (f.document.body) {
					if (f.document.body.clientWidth) {
						var wa = f.document.body.clientWidth;
					}
				}
			}
		}	
		var w = wa;

		// Move Menu
		top.menu.document.getElementById('menu').style.paddingLeft = w;
		top.menu.document.getElementById('menu').style.display = "block";

		l = get_layer('menu');
		move_layer(l, w);
		show_layer(l);
	} catch (e) {}
}

function scroll_menu() {
	scroll_menu_do(0);
}
function scroll_menu_do(posx) {
	if(posx) {
		root_posx = posx;
	} else {
		posx = root_posx;
	}
	var l = get_layer(menu_layer, menu_frame);
	if (!layer_isvisible(l)) return;
	var p = get_scrollpos(top.main.list);
	if (p[0] != scrollposx || scrollposy != p[1]) {
		move_layer(l, p[0] + posx, p[1], 1);
		scrollposx = p[0];
		scrollposy = p[1];
	}
	// disabled, coz when the menu grows too long you won't be able to scroll down the whole way as the menu will reposition while scrolling.
	// scrollTimer = setTimeout('scroll_menu('+posx+')',scrolltimeout);
}

function subON(name, index, subindex, url) {
	if (top.menu) if (top.menu.over_menu) 
		top.menu.over_menu = index;
	imgCH(subindex, url);
}
function subFF(name, index, subindex, url) {
	imgCH(subindex, url);
}
function imgCH(index, url) {
	var imgName = 'img' + index;
	var l = get_layer('nodesubmenu1');
	if (l.document && l.document.images[imgName]) {
		l.document.images[imgName].src = url;
	} else if (document.images[imgName]) {
		document.images[imgName].src = url;
	}
}
